/************************************************************************/
/*								                                             	*/
/*			Clock / Calendar				                                    */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/*                                                                      */
/************************************************************************/
#include <inttypes.h>
#include <avr/io.h>
#include "lcd.h"
#include "clock.h"

static uint8_t F_1min;
static uint8_t F_1hour;


void displayClock(void) {
   lcdCommand(0x80);                                       // line 1
   lcdData(time.hour / 10 + '0');
   lcdData(time.hour % 10 + '0');
   lcdData(':');
   lcdData(time.min / 10 + '0');
   lcdData(time.min % 10 + '0');
   lcdData(':');
   lcdData(time.sec / 10 + '0');
   lcdData(time.sec % 10 + '0');

   lcdCommand(0xC0);                                       // line 2
   lcdData(time.day / 10 + '0');
   lcdData(time.day % 10 + '0');
   lcdData('.');
   lcdData(time.month / 10 + '0');
   lcdData(time.month % 10 + '0');
   lcdData('.');
   lcdData('2');
   lcdData('0');
   lcdData(time.year / 10 + '0');
   lcdData(time.year % 10 + '0');
}


void clock(void) {
   uint8_t  i;

   time.sec++;
   if (time.sec == 60) {
      time.sec = 0;
      F_1min = 1;                                          // to correct deviation per minute
      time.min++;
      if (time.min == 60) {
         time.min = 0;
         F_1hour = 1;
         time.hour++;
         switch (time.hour) {
         case 24:
            time.hour = 0;
            time.day++;
            time.wday++;
            if (time.wday == 8)
               time.wday = 1;
            i = time.month;
            if (i == 2 && (time.year & 3) == 0)            // leap year
               i=0;
            if (MDays[i] == time.day) {
               time.day = 1;
               time.month++;
               if (time.month == 13) {
                  time.month = 1;
                  time.year++;
                  if (time.year == 100)
                     time.year = 0;                        // next century
               }
            }
            break;
//       case 2:
//       case 3: summertime(); break;
         }
      }
   }
}


