#ifndef CLOCK_H
#define CLOCK_H
/**
 * lcd-clock by peter dannegger
 *
 * via shift register 74HC164
 */
#include <inttypes.h>
#include <avr/pgmspace.h>
#ifdef EXTERN
#undef EXTERN
#endif
#ifdef PLACE_GLOBALS_HERE
#define EXTERN
#else
#define EXTERN extern
#endif

struct time {
   uint8_t  sec;
   uint8_t  min;
   uint8_t  hour;
   uint8_t  day;
   uint8_t  wday;
   uint8_t  month;
   uint8_t  year;
};

EXTERN struct time time; 
EXTERN uint8_t F_1sec;
EXTERN PROGMEM uint8_t  MDays[]
#ifdef PLACE_GLOBALS_HERE
= { 30, 32, 29, 32, 31, 32, 31, 32, 32, 31, 32, 31, 32 }
#endif
;

void displayClock(void);
void clock(void);

/*
 * timer calculations
 */
#define TIMER_IPS ((uint16_t)((F_CPU / 0xFFFF) + 0.5))     // compare match interrupts per second
#define TIMER_TL  ((uint16_t)(F_CPU / TIMER_IPS))          // top level for 16 bit interrupt 
                                                           // to get best time matching
#endif
